library basicmsgdll;



uses
  SysUtils,
  Classes,windows,messages;

var saveexit : pointer;
    msglist : tstringlist;
    tsrets,tsintmp : string;

    registeredhwnd,mainwnd,orgwindproc : longint;

    msgidinit : longint;

    bserv : boolean;

    outdatastruct: TCopyDataStruct;





function winmsghook(Window: HWND; Message, WParam: Longint;LParam: Longint): Longint; stdcall;
begin
     // trap init messages
     if message =  msgidinit then
     begin
          result := 0;
          // if I didnt send it and we dont already have a registered converseeeee and its and init message (wparam =0)
          if (lparam <> mainwnd) and (registeredhwnd = 0) and (Wparam = 0) then
          begin
               registeredhwnd := lparam;
               // if im the server then post a message back to the client to tell it my window handle
               if bserv then postmessage(registeredhwnd,msgidinit,0,mainwnd);
               result :=1;
          end
          else
          // else detach our connected window ?
          if (lparam <> mainwnd) and (registeredhwnd <> 0) and (Wparam = 1)  then
          begin
               registeredhwnd := 0;
               result :=1;
          end;
     end
     else
     // trap copy data messages
     if (message = wm_copydata) then
     begin
          result := 0;
          if (registeredhwnd <> 0) then
          begin
               if (PCopyDataStruct(LParam)^.dwData = dword(registeredhwnd)) then
               begin
                    tsintmp := string(pchar(PCopyDataStruct(LParam)^.lpData));
                    setlength(tsintmp,PCopyDataStruct(LParam)^.cbData);
                    msglist.add(tsintmp);
                    result := 1;
               end
               else
               // pass message to original wndproc
               result := callwindowproc(pointer(orgwindproc),window,message,wparam,lparam);
          end
          else
          // pass message to original wndproc
          result := callwindowproc(pointer(orgwindproc),window,message,wparam,lparam);
     end
     else
     // pass message to original wndproc
     result := callwindowproc(pointer(orgwindproc),window,message,wparam,lparam);
end;


function getappwindow(hnd : longint ) :longint;
var th : longint;
begin
     th := hnd;
     result :=0;
     while th <> 0 do
     begin
          th := getparent(th);
          if th <> 0 then result := th;
     end;
end;

procedure hookwnd(hnd : longint);
begin
     orgwindproc := getwindowlong(hnd,gwl_wndproc);
     setwindowlong(hnd,gwl_wndproc,longint(@winmsghook));
end;

function msginit(handle,serv : longint) : longint; stdcall;
begin
     result := 0;
     if msglist = nil then msglist := tstringlist.create;
     if serv <>0 then
     begin
          if mainwnd = 0 then
          begin
               // set up as a server
               mainwnd := getappwindow(handle);
               hookwnd(mainwnd);
               bserv := true;
               result := 1;
          end;
     end
     else
     begin
          if mainwnd = 0 then
          begin
               //// set up as a client;
               mainwnd := getappwindow(handle);
               hookwnd(mainwnd);
               // broadcast to get a server
               postmessage(hwnd_broadcast,msgidinit,0,mainwnd);
               result :=1;
           end
           else
           if registeredhwnd = 0 then
           begin
               // broadcast to get a server
                postmessage(hwnd_broadcast,msgidinit,0,mainwnd);
                result :=2;
           end;
     end;
end;


function isconnected : longint; stdcall;
begin
     result := registeredhwnd;
end;


function msgcount : longint; stdcall;
begin
     if msglist <> nil then
     result := msglist.count
     else
     result := 0;
end;


function msggetmsg : pchar; stdcall;
begin
     tsrets := '';
     if msglist <> nil then
     begin
          if msglist.count > 0 then
          begin
               tsrets := msglist[0];
               msglist.Delete(0);
          end;
     end;
     result := pchar(tsrets);
end;

function msgsendmsg( ts : pchar) : longint; stdcall;
begin
     result :=0;
     if registeredhwnd <> 0 then
     begin
           outDataStruct.dwData := mainwnd;
           outDataStruct.cbData := strlen(ts);
           outDataStruct.lpData := ts;

           result := SendMessage(registeredhwnd, wm_copydata, 0, LParam(@outDataStruct));
     end;
end;

procedure deinitdll; stdcall;
begin
     // post message to dettach this window
   if registeredhwnd <> 0 then postmessage(registeredhwnd,msgidinit,1,mainwnd);

  // unhook window proc?
  if (orgwindproc <> 0) and (mainwnd <>0) then
     setwindowlong(mainwnd,gwl_wndproc,orgwindproc);

  // free stringlist (msg inbox) ?
  if msglist <> nil then msglist.free;

  mainwnd :=0;
  registeredhwnd :=0;
  msglist := nil;
  orgwindproc :=0;
  bserv := false;
end;

procedure LibExit;
begin
 deinitdll;
  // restore exit procedure chain
  ExitProc := SaveExit;
end;


exports
       msginit index 1,
       msgcount index 2,
       msggetmsg index 3,
       msgsendmsg index 4,
       isconnected index 5,
       deinitdll index 6;

begin
   // library initialization code

    msglist := nil;
    mainwnd := 0;
    registeredhwnd :=0;
    orgwindproc :=0;
    bserv := false;
    msgidinit := registerwindowmessage(Pchar('basicmsginit'));

    SaveExit := ExitProc;  // save exit procedure chain
    ExitProc := @LibExit;  // install LibExit exit procedure
end.
